#pragma once
#include <iostream>
#include <cstdio>
#include <vector>

#define  IN
#define OUT
#define INOUT

using namespace std;

class CivDbConn;

/**
 *@brief  ߽ṹģ
 *@param weight Ȩ
 */
template <class EdgeType>
struct Edge
{
    int nDestVertex; // Ŀڵ

    EdgeType edgeObj;  // ߵֵ

    Edge<EdgeType>* pNextEdge; // һ

    Edge(int d, weight c, Edge<EdgeType>* p = NULL)
        :nDestVertex(d), edgeObj(c), pNextEdge(p)
    {}
};

/**
 *@brief  ڵṹģ
 *@param vertextype ڵ
 *@param weight Ȩ
 */
template <class   VertexType, class EdgeType>
struct Vertex
{
    VertexType mVertex;
    
    Edge<EdgeType>* pAdjEdges;

    Vertex(VertexType x, Edge<EdgeType>* p = NULL)
        :mVertex(x), pAdjEdges(p)
    {}
};

/**
   ڽӱͼ
*/
template <class   VertexType, class EdgeType>
class ALGraph
{
public:
    explicit ALGraph();
    ~ALGraph();

    /**
    *@brief ͼ
    */
    void createGraph(CivDbConn* dbConn);

public:
    
    /**
    *@brief ͼвһڵ
    *@param vertexName ڵֵ
    */
    bool insertAVertex(IN const VertexType& vertexName);

    /**
    *@brief ڵ֮һ
    *@param vertexName1 ڵ1
    *@param vertexName2 ڵ2
    *@param edge 
    */
    bool insertAEdge(IN const VertexType vertexName1, IN const VertexType vertexName2, IN const EdgeType edge);

    /**
    *@brief Ƴڵı
    *@param vertexName1 ڵ1
    *@param vertexName2 ڵ2
    *@param edge 
    */
    bool removeAEdge(IN const VertexType& vertexName1, IN const VertexType& vertexName2, IN const EdgeType& edgeWeight);

    /**
     *@brief ȡڵ֮ӵСȨֵ
     *@param vertexName1  ڵ1
     *@param vertexName2  ڵ2
     */
    EdgeType getMinWeight(IN const VertexType vertexName1, IN const VertexType vertexName2);

    /**
     *@brief ȡڵ֮ӵСȨֵ
     *@param vertexName1  ڵ1
     *@param vertexName2  ڵ2
     */
    int getVertexIndex(IN const VertexType vertexName);

    int getVertexNumber();

    VertexType getData(IN int index);

    int Dijkstra(IN const VertexType vertexName1);

    void DijkstraPrint(IN int index, IN int sourceIndex, IN vector<int> vecPreVertex);

    friend ostream& operator<<(OUT ostream& out, IN const ALGraph<VertexType, EdgeType>& graphInstance);

public:

    EdgeType getEdgeWeight(IN const Edge<EdgeType>* pEdge);

    void getVertexEdgeWeight(IN const int v1, OUT vector<EdgeType>& DistanceArray);

    vector< Vertex<VertexType, EdgeType> > m_vertexArray;
};



