#pragma once
#include <string>
#include <sstream>
#include <vector>
#include "CivTypes.h"

#define CivItem std::vector<std::string>
#define Civitems std::vector<CivItem>


// ģѡ
struct Options {
	// ĵλ
	enum class  UNITS
	{
		LPS,// / 
		LPM,// / 
		MLD,// / 
		CMH,// / Сʱ
		CMG,// / 
		CFS,//Ӣ / 
		GPM,// / 
		MGD,// / 
		IMGD,//ӢMGD
		AFD,//ӢĶ - Ӣ / 
	};

	// ˮͷʧʽ
	enum class  HEADLOSS {
		HW,   // Hazen - WilliamsH - W
		DW,  //Darcy - Weisbach(D - W)
		CM //Chezy - Manning(C - M)
	};

	// ˮʷ
	enum class  QUALITY
	{
		NONE, //NONEޣ
		CHEMICAL, //CHEMICALѧҩ
		AGE, // AGEˮ䣩
		TRACE // TRACE٣
	};

	UNITS units;
	HEADLOSS headLoss;
	QUALITY quality;
	Str VISCOSITY = "0.1"; // ģ˶ճ
	Str  DIFFUSIVITY = "1.0"; // ǻķɢϵ
	Str SpecificGravity = "1.0"; // ģܶ4϶ˮ֮ܶȣ٣
	Str TRIALS = "40"; // ˮʹõ
	Str ACCURACY = "0.001"; //ָȷʱﵽˮ׼
	Str  UNBALANCED = "STOP"; //STOPڸõֹCONTINUEڹϢ
	Str Pattern = "1";
	Str DEMANDMULTIPLIER = "1.0"; // ڵӽڵĻˮֵԼˮ͡
	Str EMITTEREXPONENT = "0.5"; // ָ˵ɢʱڵѹָ
	Str TOLERANCE = "0.01"; //ˮˮƽ
	Str MAP;
};


/**
   inpļģ
*/
class CivInp
{
public:
	// ʱ䵥λ
	enum TimeUnit { SECONDS, MINUTES, HOURS, DAYS };

	CivInp(TimeUnit timetype);

	/**
	*@brief inpļ
	*@paramfileName: ļ
	*/
	bool writeToFile(const char* fileName);
	
	/**
	*@brief 
	*@param items: 
	*@param type: ö
	*/
	void writeComponet(const Civitems& items, SectType type);

	/**
	*@brief дIO
	*/
	void writeTextStream();

	/**
	*@brief ʱģʽ
	*@param pId: ģʽid
	*@param pValue: ģʽֵ
	*/
	void setPattern(StrQuote pId, std::vector<Str> pValue);

	/**
	*@brief 岻ͬģѡ
	*@param options: ѡ
	*@param others: ѡֶ
	*/
	void setOption(Options options,const std::map<std::string,std::string>& others = std::map<std::string, std::string>());

	/**
	*@brief ģʱ
	*@param duration ʱ
	*/
	void setDuration(int duration);

	/**
	*@brief ʱ
	*@param typeҪõʱ䲽ģͣPATTERNREPORTQUALITY 
	*@param step :ʱ
	*/
	void setTimestep(Str type, int step);

	void setTimeStart(Str type, int step);

	void setTimeOthers(Str type, Str val);
	/**
	*@brief ʱ䵥λ
	*/
	void setTimeUnit(TimeUnit timeUnit) { mTimeUnit = timeUnit; }
private:
	Str getTimeUnit(TimeUnit timetype);
	void writeTitles();
	void writeJunctions(Civitems items);
	void writePipes(Civitems items);
	void writeTanks(Civitems items);
	void writeReservoirs(Civitems items);
	void writePumps(Civitems items);
	void writeValves(Civitems items);
	void writeTags(Civitems items);
	void writeCoordinates(Civitems items);
	void writeLabels(Civitems items);
	void writeVertices(Civitems items);
	void writeSources(Civitems items);
	void writeBackdrop(Civitems items);
	void writeEnd();
	void writeString(const std::string& s);
	void writeStatus(Civitems items);
	void writeCurves(Civitems items);
	void writeTimes(Civitems items);

	void writeControls(Civitems items);
	void writeReactions(Civitems items);
	void writeMixing(Civitems items);
	void writeRules(Civitems items);
	void writeEnergy(Civitems items);
	void writeEmitters(Civitems items);
	void writeQuality(Civitems items);
	void writeItems(const Civitems& items);
	void writeOptions(const Civitems& items);
	void writePatterns(Civitems items);
	void writeDemand(Civitems items);
private:
	std::ostringstream mTextStream;

	TimeUnit mTimeUnit; // ʱ䵥λ

	Civitems mJunctionsItems;  // ڵ
	Civitems mPipesItems; // 
	Civitems mReservoirsItems; // ˮԴ
	Civitems mTanksItems;// ˮ
	Civitems mPumpsItems; // ˮ
	Civitems mValvesItems; // 
	Civitems mTagsItems;  // 
	Civitems mStatusItems; // ģ⿪ʼʱѡܶεĳʼ״̬
	Civitems mPatternsItems; // ʱģʽ
	Civitems mCurvesItems; // 
	Civitems mControlsItems; // Ʋ
	Civitems mRulesItems; // ڹƣ״޸ĹܶΡ
	Civitems mEnergyItems; // ˮͳɱĲ
	Civitems mEmittersItems; // ģڵ㶨Ϊɢ߿׿ڣ
	Civitems mQualityItems; // ڵĳʼˮʡ
	Civitems mDemandsItems; //ӽڵĶģʽˮǶ[JUNCTIONS]Ĳ䡣
	Civitems mSourceItems; //ˮԴͷλá
	Civitems mReactionItems; //Ӧڹ뻯ѧɷַӦĲ
	Civitems mMixingItems; // ȷˮػϵģ͡

	Civitems mReportItems; //ģɵݡ
	Civitems mOptionsItems; // 岻ͬģѡ
	Civitems mCoordinatesItems; // 
	Civitems mVerticesItems; //ڲ㸳ֵܶΡ
	Civitems mLabelsItems; // ͼǩֵ
	Civitems mBackdropItems; // ʶͼıͼߴ硣
	Civitems mTImesItems;//ģеĸ¼ʱ䲽
};
