#ifndef CIVNEWINP_H
#define CIVNEWINP_H
#include <sstream>
#include <string>
#include "CivAssembly.h"
#include <list>


// ˮʷö
typedef enum
{
	ANALYSIS_TRACE = 1,	//׷ٷ
	ANALYSIS_AGE = 2,	//ˮ
	ANALYSIS_CONCENTRATION = 3,	//
	ANALYSIS_RESERVE = 4, //ϵͳûʹ
}QualityAnalyType;

// 
#define OPTIONS "OPTIONS"
#define TIMES "TIMES"
#define REACTIONS "REACTIONS"
#define ENERGY "ENERGY"
#define REPORT "REPORT"
#define COORDINATES "COORDINATES"

/**
   תinpļ
*/
class CivNewInp
{
public:
	explicit CivNewInp();
	~CivNewInp();
	
	bool writeToFile(char* fileName);
	/**
		
	*/
	void setQualityType(QualityAnalyType type,const std::string& qualityName);
	void setTtitle(const std::string& title);
	void setNode(const CivNode& node);
	void setPipes(const CivPipe& pipes);
	void setTank(const CivTank& tank);
	void setReservoirs(const  CivReservoirs& res);
	void setValves(const CivValve& valve);
	void setPumps(const CivPumps& pumps);
	void setEmitters(const CivEmitters& mitters);

	// ϵͳ
	void setCurves(const CivCurves& cureves);
	void setPatterns(const CivPatterns& patterns);	
	void setStatus(const CivStatus& status);
	void setControls(const std::string& control);
	void setRules(const std::string& ruleName, const std::string& rules);
	void setDemands(const CivDemands& demands);

	// ˮ
	void setQuality(const CivQuality& quality);
	void setSources(const CivSources& sources);
	void setMixing(const CivMixing& mixing);

	// ѡͱ ͳһȡ
	void setReactions(const CivParameter& params);
	void setOptions(const CivParameter& params);
	void setTimes(const CivParameter& params);
	void setReport(const CivParameter& params);
	void setEnergy(const CivParameter& params);

	void setParamter(const CivParameter& params, const std::string& type);


	//ͼ/ǩ
	void setCoordnates(const CivCoordinates& coords);
	void setVertices();
	void setLabels(const CivLabels& labels);
	void setBackDrop();
	void setTags(const CivTags& tags);

private:
	void inline writeString(const std::string& s);
	void inline writeStringFormat(const std::string& s, const std::string& sep="\t");
	void inline writeHead(const std::string& head);
	std::string currentTime();

private:

	std::ostringstream mTextStream;
	QualityAnalyType mQualityType = ANALYSIS_AGE; //ˮʷ, Ĭˮ
	std::string mQualityName; // ׷ٵĽڵ ߻
	std::map<std::string, void (CivNewInp::*)(const CivParameter&)> mParamMap; // ӳ
};
#endif // !CIVNEWINP_H

