#ifndef CIVASSEMBLY_H
#define CIVASSEMBLY_H
#include "CivTypes.h"
#include <list>
#pragma warning(disable:4251)
#define DBEXPORT __declspec(dllexport)

class CivAssembly;
class CivNode;
class CivPipe;
class CivTank;
class CivValve;
class CivPumps;
class CivEmitters;
class CivCoordinates;
class CivMixing;
class CivLabels;
class CivTags;

/**
	 
*/
class CivAssembly
{
};

/**
   ڵ
 */
class DBEXPORT CivNode: public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ID   Elev  Demand  	Pattern
		Str ID;
		Str Elev;
		Str Demand;
		Str PatternId;
	}  NodeTable;

	void addItem(const NodeTable& table);
	std::list<NodeTable> mTables;
};

/**
 * 
 */
class DBEXPORT CivPipe: public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ID  Node1   Node2   Length   Diameter  	Roughness  MinorLoss  Status
		Str ID;
		Str Node1;
		Str Node2;
		Str Length;
		Str Diameter;
		Str Roughness;
		Str MinorLoss;
		Str Status;
	}  PipesTable;

	void addItem(const PipesTable& table);
	std::list<PipesTable> mTables;
};


/*
	ˮ
*/
class DBEXPORT CivTank:public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ID   Elevation  InitLevel  MinLevel   MaxLevel   Diameter   MinVol   VolCurve
		Str ID;
		Str Elev;
		Str InitLevel;
		Str MinLevel;
		Str MaxLevel;
		Str Diameter;
		Str MinVol;
		Str VolCurve;
	}  TankTable;

	void addItem(const TankTable& table);
	std::list<TankTable> mTables;
};

/*
 ڹпƷš
*/
class DBEXPORT CivValve :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			ŵIDǩ
			ʼڵID
			ֹڵID
			ֱmmӢ磩
			
			
			ֲʧϵ
		*/
		Str ID;
		Str Node1;
		Str Node2;
		Str Diameter;
		Str Type;
		Str Setting;
		Str MinorLoss;
	}  ValveTable;

	void addItem(const ValveTable& table);
	std::list<ValveTable> mTables;
};

/**
  ˮ
*/
class DBEXPORT CivPumps :public CivAssembly
{
public:
	typedef struct  Table
	{
		// ;ID   Node1   Node2   Parameters
		Str ID;
		Str Node1;
		Str Node2;
		Str Parameters;
	}  PumpTable;

	void addItem(const PumpTable& table);
	std::list<PumpTable> mTables;
};

/*
аˮڵ
*/
class DBEXPORT CivReservoirs :public CivAssembly
{
public:
	typedef struct  Table
	{
		/* 
			IDǩ
			ˮͷft(m)
			ˮͷģʽIDѡ
		*/
		Str ID;
		Str Head;
		Str Pattern;
	}  ReservoirsTable;

	void addItem(const ReservoirsTable& table);

	std::list<ReservoirsTable> mTables;
};

/**
   EMITTERSģڵ㶨Ϊɢ߿׿ڣ
*/
class DBEXPORT CivEmitters :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			ӽڵIDǩ
			ϵ1ף1 psiѹµλ
		*/
		Str ID;
		Str coeff;
	}  EmittersTable;

	void addItem(const EmittersTable& table);
	std::list<EmittersTable> mTables;
};

/**
  
*/
class DBEXPORT CivCoordinates :public CivAssembly
{
public:
	typedef struct  Table
	{
		// ; ;Node     X-Coord     Y-Coord
		Str ID;
		Str XCoord;
		Str YCoord;
	}  CoordTable;

	void addItem(const CoordTable& table);
	std::list<CoordTable> mTables;
};

/**
	ѡ
*/
class DBEXPORT  CivMixing :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			ˮIDǩ
			ģͣMIXED, 2COMP, FIFOLIFO
			ҵݻС
		*/
		Str ID;
		Str hyModel;
		Str volume;
	}  MixingTable;

	void addItem(const MixingTable& table);
	std::list<MixingTable> mTables;
};

/**
   ȷˮػϵģ͡
*/
class DBEXPORT  CivParameter :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
			[OPTIONS]
			[TIMES]
			[REACTIONS]
			[ENERGY] 
			[REPORT]
		*/
		Str name;
		Str val;
	} ParamTable;

	void addItem(const ParamTable& table);
	void setType(const std::string& type) { mType = type; }

	std::string mType;
	std::list<ParamTable> mTables;
};

/**
  ģʽ
*/
class DBEXPORT CivPatterns :public CivAssembly
{
public:
	typedef struct  Table
	{
		Str name; // ģʽ
		Str val; // ģʽֵ
	} PatternTable;

	void addItem(const PatternTable& table);
	std::list<PatternTable> mTables;
};

/*
	߼XY㡣
*/
class DBEXPORT CivCurves :public CivAssembly
{
public:
	typedef struct  Table
	{
		Str ID; // ģʽ
		Str XCoord; // Xֵ
		Str YCoord; // Yֵ
	} CurvesTable;

	void addItem(const CurvesTable& table);
	std::list<CurvesTable> mTables;
};

/**
	ӽڵĶģʽˮǶ[JUNCTIONS]Ĳ䡣
*/
class DBEXPORT CivDemands :public CivAssembly
{
public:
	typedef struct  Table
	{
		/* 
			ӽڵIDǩ
		    ˮλ
			ˮģʽIDѡ
			ֺ֮ˮƣѡ
		*/
		Str ID; 
		Str BaseDemand; 
		Str PatternId; 
		Str DemandType;
	} DemandsTable;

	void addItem(const DemandsTable& table);
	std::list<DemandsTable> mTables;
};

// ˮԴͷλá
class DBEXPORT  CivSources :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		ڵIDǩ
        ԴͷͣCONCEN, MASS, FLOWPACEDSETPOINT
        ׼Դͷǿ
        ʱģʽIDѡ;Node  Type  Quality  Pattern
		*/
		Str ID;
		Str Type;
		Str Quality;
		Str Pattern;
	} CurvesTable;

	void addItem(const CurvesTable& table);
	std::list<CurvesTable> mTables;
};

// ģ⿪ʼʱѡܶεĳʼ״̬
class DBEXPORT CivStatus :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		   ܶIDǩ
           ״̬ ID    Status/Setting
		*/
		Str ID;
		Str Setting;
	} StatusTable;

	void addItem(const StatusTable& table);
	std::list<StatusTable> mTables;
};

// ڵĳʼˮʡ
class DBEXPORT CivQuality :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		    ڵIDǩ
            ʼˮ
		*/
		Str ID;
		Str InitQuality;
	} QualityTable;

	void addItem(const QualityTable& table);
	std::list<QualityTable> mTables;
};

// ͼǩֵ
class  DBEXPORT CivLabels :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		  X
		  Y
		   ˫еıǩı
		   êڵIDǩѡ
		*/
		Str XCoord;
		Str YCoord;
		Str Label;
		Str ID;
	} LabelTable;

	void addItem(const LabelTable& table);

	std::list<LabelTable> mTables;
};

// ͱǩضڵ͹ܶ
class DBEXPORT CivTags :public CivAssembly
{
public:
	typedef struct  Table
	{
		/*
		   ؼΪNODELINK
		   ڵ߹ܶIDǩ
		   ǩı޿ո
		*/
		Str Key;
		Str Id;
		Str Label;
	} TagsTable;

	void addItem(const TagsTable& table);
	std::list<TagsTable> mTables;
};

#endif // !CIVASSEMBLY_H

