#ifndef CIVDBCONN_H
#define CIVDBCONN_H
#include "CivTypes.h"
#include "CivAssembly.h"
#include "CivTableTemp.h"

#define DBEXPORT __declspec(dllexport)

/**
 ݿӽӿ
*/
class DBEXPORT CivDbConn
{
public:
	CivDbConn();
	virtual ~CivDbConn();

	// ȡ
	virtual bool getNode(CivNode& node)=0;
	virtual bool getPipe(CivPipe& pipe)=0;
	virtual bool getTank(CivTank& tank)=0;
	virtual bool getValve(CivValve& valve)=0;
	virtual bool getPumps(CivPumps& pump)=0;
	virtual bool getReservoirs(CivReservoirs& reservoirs)=0;
	virtual bool getEmitters(CivEmitters& emitter)=0;
	virtual bool getCoordinates(CivCoordinates& coord)=0;
	virtual bool getMixing(CivMixing& mixing)=0;
	virtual bool getParameter(std::vector <CivParameter>& params)=0;
	virtual bool getPatterns(CivPatterns& patterns)=0;
	virtual bool getCurves(CivCurves& curves)=0;
	virtual bool getDemands(CivDemands& demands)=0;
	virtual bool getSources(CivSources& sources)=0;
	virtual bool getStatus(CivStatus& status)=0;
	virtual bool getQuality(CivQuality& quality)=0;
	virtual bool getLabels(CivLabels& labels)=0;
	virtual bool getTags(CivTags& tags)=0;

	/**
	*@brief ݿ⣬йʵ
	*/
	virtual bool open() = 0;

	/**
	*@brief رݿӣйʵ
	*/
	virtual void close() = 0;

	/**
	*@brief жĳűǷڣжϷݿйأӳٵʵ
	*@param tableName: 
	*/
	virtual bool tableExist(StrQuote tableName) = 0;

	/**
	 *@brief 
	 */
	virtual bool createTable(CivTableTemp& temp) =0 ;

	/**
	*@brief ֵֶɾ
	*@param table
	*@param filedNameֶ
	*@param fieldValueֵֶ
	*/
	virtual bool deleteByField(StrQuote table, StrQuote filedName, StrQuote fieldValue) =0 ;

	/**
	 *@brief ʱνݻڵ
	 *@param currDate ַ ʽ xxxx-xx-xx
	 *@param interval ʱ
	 */
	virtual bool updateNodeByInterval(StrQuote currDate, StrQuote interval)=0;

	/**
	 *@brief ʱν߱ݻ߱
	 *@param currDate ַ ʽ xxxx-xx-xx
	 *@param interval ʱ
	 */
	virtual bool updateLinkByInterval(StrQuote currDate, StrQuote interval)=0;

	/**
	 *@brief µ
	 *@param nodeItemsҪµֵ
	 */
	virtual bool updateNode(const NodeResultItems& nodeItems) = 0;

	/**
	 *@brief ߱
	 *@param: lineItems: 
	 */
	virtual bool updateLink(const LinkResultItems& lineItems) = 0;

	/**
	 *@brief ִsql
	 *@param: sql Ҫִеsql
	 */
	virtual bool execSql(StrQuote sql) = 0;

	/**
	 *@brief ȡֶָϢ
	 *@param  fileds ҪѯЩֶ
	 *@param  result ѯĽ
	 */
	virtual bool getFieldValueFromTable(const std::string& table, 
		const std::vector<std::string>& fileds,
		std::vector< std::vector<std::string>>& result) = 0;


	/**
	 *@brief ȡĳֶָεֵ
	 *@param  table ѯı
	 *@param  condition ѯ
	 *@param  fileds ҪѯЩֶ
	 *@param  result ѯĽ
	 */
	virtual bool getValuesFromTableByCondition(const std::string& table,
		const std::string& condition,
		const std::vector<std::string>& fileds,
		std::vector< std::map<std::string, std::string>>& result) = 0;

	virtual void checkHyDrNetTable() = 0;
	// ȡǰִдϢ
	Str getLastError() const; 
	
	bool isValid() const;

protected:
	bool mIsOpen = false; // ݿϢ
	char* mLastError; // ִsqlĴϢ
};


#endif // !CIVDBCONN_H

