#pragma once
#include "CivTypes.h"
#include <vector>
#include <set>
#include <libpq-fe.h>
#include "CivTableTemp.h"
#include "CivSysLog.h"

#define DLLEXPORT __declspec(dllexport)

class CivDbConnection;

/**
  ݿ࣬ȡݣдݽӿ
*/
class DLLEXPORT  CivDbConnection
{
public:
	CivDbConnection(char* uri);
	~CivDbConnection();

	/**
	 *@brief ȡб
	 *@netName: 
	 */
	Tables getTables(StrQuote netName, StrQuote schema = "public");

	/**
	 *@brief ȡݣߣڵ㣬ˮԴȣ
	 *@tableName 
	 */
	Componets getComponets(StrQuote tableName);

	Componets getComponetsByWhere(StrQuote tableName, StrQuote where);

	/**
	 *@brief  ˮã (ڵתΪ)
	 *@tableName 
	 */
	Componets getLikelyPipes(StrQuote tableName);

	bool tableExist(StrQuote tableName);

	/**
	 *@brief 
	 *@tableName: 
	 *@schema: 
	 *@tableType߽ͣ
	 */
	bool createTable(CivTableTemp& temp);

	bool deleteByDate(StrQuote table, StrQuote filedName, StrQuote fieldValue);

	bool updateNodeByInterval(StrQuote currDate, StrQuote interval);

	bool updateLinkByInterval(StrQuote currDate, StrQuote interval);

	/**
	*@brief ˢģˮֵֶ
	*@quality: ˮ
	*@currDate: ģ
	*@StrQuote: ģĴ
	*/
	bool updateNodeQuality(const NodeResultItems& nodeItems);
	bool updatePipeQuality(const LinkResultItems& lineItems);
	/**
	 *@brief µ
	 *@nodeItemsҪµֵ
	 */
	bool updateNode(const NodeResultItems& nodeItems);

	/**
	 *@brief ߱
	 *@lineItems: 
	 */
	bool updateLink(const LinkResultItems& lineItems);

	bool open();
	void close();

	void addFilter(Str type, Str number);

	FiledFilter getFilter() const;

private:
	bool isValid() const;

	/**
	 *@brief ѯӵ
	 *@table: ߱
	 *@code:
	 */
	Componets getLineByCode(StrQuote table, StrQuote code);

	Componets getNodeByCode(StrQuote table, StrQuote code);

	/**
	 *@brief ִsql
	 *@sql: Ҫִеsql
	 */
	bool execSql(std::string sql);

	void clearResult();

	/**
	 *@brief Ӳѯȡ
	 *@result: ѯ
	 *@comp: 
	 */
	void getData( Componets& comp);

private:
	PGconn* mConn;
	PGresult* mResult;
	bool mIsOpen = false;
	char* mUri;

	char* mLastError;
	FiledFilter mFilter; // :Ӧı
};