#include "CivTableTemp.h"
#include "CivDbConn.h"

CivTableTemp::CivTableTemp()
{
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_INT, "int"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_INTEGER,"integer"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_DOUBLE, "double precision"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR, "varchar(32)"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR64, "varchar(64)"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR128, "varchar(128)"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR256,"varchar(256)"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_DATETIME, "timestamp"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_JSON, "json"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_DATE, "date"));
}

CivTableTemp::~CivTableTemp()
{

}

void CivTableTemp::addProperty(Str fileName, FieldType filedType)
{
	FieldProperty prop = { fileName ,mFieldTyepMap.find(filedType)->second};
	mPropertys.push_back(prop);
}

Str CivTableTemp::createSql()
{
	if (mPropertys.size() <= 0)
		return Str();

    char sql[512] = "create table ";

	strcat_s(sql, mTableName.c_str());
	strcat_s(sql, "(id serial primary key");
	size_t total = mPropertys.size();
	for (int i = 0; i < total; i++)
	{
		FieldProperty property = mPropertys[i];
		strcat_s(sql, ",");
		strcat_s(sql, property.mFiledName.c_str());
		strcat_s(sql, "  ");
		strcat_s(sql, property.mFieldType.c_str());
	}
	strcat_s(sql, ")");

	return sql;
}

bool CivTableTemp::updateToDb(CivDbConn* dbConn)
{
    if (dbConn == nullptr)
        return false;

    Str sql = createSql();
    return true;
}

CivJunctionTableTemp::CivJunctionTableTemp(Str tableName)
{
    setName(PIPENODE);

    TableFileds fileds;
     addProperty(fileds.ID ,CivTableTemp::FILED_VARCHAR);// "id";
     addProperty(fileds.geom ,CivTableTemp::FILED_VARCHAR);// "geom";
     addProperty(fileds.thePoint ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.xCoord ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.yCoord ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.elev ,CivTableTemp::FILED_VARCHAR);// "߳";
     addProperty(fileds.demand ,CivTableTemp::FILED_VARCHAR);// "ˮ";
     addProperty(fileds.pattern ,CivTableTemp::FILED_VARCHAR);// "ˮģʽ";
     addProperty(fileds.head ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
     addProperty(fileds.freeHead ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
     addProperty(fileds.actualDemand ,CivTableTemp::FILED_VARCHAR);// "ʵˮ";
     addProperty(fileds.code ,CivTableTemp::FILED_VARCHAR);// "code";
     addProperty(fileds.createUser ,CivTableTemp::FILED_VARCHAR);// "create_user";
     addProperty(fileds.modifyUser ,CivTableTemp::FILED_VARCHAR);// "modify_user";
     addProperty(fileds.createTime ,CivTableTemp::FILED_VARCHAR);// "create_time";
     addProperty(fileds. modifyTime ,CivTableTemp::FILED_VARCHAR);// "modify_time";
     addProperty(fileds.symbolAngle ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
     addProperty(fileds.compType ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.pressure ,CivTableTemp::FILED_VARCHAR);// "ѹ";
     addProperty(fileds.quality ,CivTableTemp::FILED_VARCHAR);// "ˮ";
};

/**
߱ģ
*/
CivPipeTableTemp::CivPipeTableTemp() :CivTableTemp()
{
    setName(PIPELINE);

    TableFileds fileds;
     addProperty(fileds.ID ,CivTableTemp::FILED_VARCHAR);// "id";
     addProperty(fileds.geom ,CivTableTemp::FILED_VARCHAR);// "geom";
     addProperty(fileds.snNo ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.thePoint ,CivTableTemp::FILED_VARCHAR);// "ϵ";
     addProperty(fileds.lastPoint ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.length ,CivTableTemp::FILED_VARCHAR);// "ܳ";
     addProperty(fileds.material ,CivTableTemp::FILED_VARCHAR);// "ܲ";
     addProperty(fileds.diameter ,CivTableTemp::FILED_VARCHAR);// "ܾ";
     addProperty(fileds.friction ,CivTableTemp::FILED_VARCHAR);// "Ħϵ";
     addProperty(fileds.localLoss ,CivTableTemp::FILED_VARCHAR);// "ֲʧϵ";
     addProperty(fileds.initStatus ,CivTableTemp::FILED_VARCHAR);// "ʼ״̬";
     addProperty(fileds.buryingTime ,CivTableTemp::FILED_VARCHAR);// "ʱ";
     addProperty(fileds.flow ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.velocity ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.unitHeadLoss ,CivTableTemp::FILED_VARCHAR);// "λˮͷ";
     addProperty(fileds.headLoss ,CivTableTemp::FILED_VARCHAR);// "ˮͷʧ";
     addProperty(fileds.unitPressLoss ,CivTableTemp::FILED_VARCHAR);// "λѹ";
     addProperty(fileds.pressLoss ,CivTableTemp::FILED_VARCHAR);// "ѹʧ";
     addProperty(fileds.lastHead ,CivTableTemp::FILED_VARCHAR);// "ϵˮͷ";
     addProperty(fileds.theHead ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
     addProperty(fileds.lastPress ,CivTableTemp::FILED_VARCHAR);// "ϵѹ";
     addProperty(fileds.thePress ,CivTableTemp::FILED_VARCHAR);// "ѹ";
     addProperty(fileds.localHeadLoss ,CivTableTemp::FILED_VARCHAR);// "ֲˮͷ";
     addProperty(fileds.fracHeadLoss ,CivTableTemp::FILED_VARCHAR);// "Ħˮͷ";
     addProperty(fileds.status ,CivTableTemp::FILED_VARCHAR);// "״̬";
     addProperty(fileds.guid ,CivTableTemp::FILED_VARCHAR);// "guid";
     addProperty(fileds.code ,CivTableTemp::FILED_VARCHAR);// "code";
     addProperty(fileds.fromCode ,CivTableTemp::FILED_VARCHAR);// "from_code";
     addProperty(fileds.fromLayer ,CivTableTemp::FILED_VARCHAR);// "from_layer";
     addProperty(fileds.toCode ,CivTableTemp::FILED_VARCHAR);// "to_code";
     addProperty(fileds.toLayer ,CivTableTemp::FILED_VARCHAR);// "to_layer";
     addProperty(fileds.createUser ,CivTableTemp::FILED_VARCHAR);// "create_user";
     addProperty(fileds.modifyUser ,CivTableTemp::FILED_VARCHAR);// "modify_user";
     addProperty(fileds.createTime ,CivTableTemp::FILED_VARCHAR);// "create_time";
     addProperty(fileds.modifyTime ,CivTableTemp::FILED_VARCHAR);// "modify_time";
     addProperty(fileds.remarks ,CivTableTemp::FILED_VARCHAR);// "ע";
     addProperty(fileds.quality ,CivTableTemp::FILED_VARCHAR);// "ˮ";
}

/**
ˮ
*/
CivPumpTableTemp::CivPumpTableTemp() :CivTableTemp()
{
    setName(PUMP);

    TableFileds fileds;
    addProperty(fileds.ID, CivTableTemp::FILED_VARCHAR);// "id";
    addProperty(fileds.geom, CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.thePoint, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.xCoord, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.startPoint, CivTableTemp::FILED_VARCHAR);// "ʼڵ";
    addProperty(fileds.endPoint, CivTableTemp::FILED_VARCHAR);// "ֹڵ";
    addProperty(fileds.curve, CivTableTemp::FILED_VARCHAR);// "ˮ";
    addProperty(fileds.ratio, CivTableTemp::FILED_VARCHAR);// "תٱ";
    addProperty(fileds.flow, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.headCurve, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.status, CivTableTemp::FILED_VARCHAR);// "״̬";
    addProperty(fileds.code, CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser, CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modifyUser, CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime, CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime, CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.SymbolAngle, CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.power, CivTableTemp::FILED_VARCHAR);// "";
}

/**
   ˮ
*/
CivTankTableTemp::CivTankTableTemp() :CivTableTemp()
{
    setName(TANK);

    TableFileds fileds;
    addProperty(fileds.ID  ,CivTableTemp::FILED_VARCHAR);// "id";
    addProperty(fileds.geom  ,CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.thePoint  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.xCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.elev  ,CivTableTemp::FILED_VARCHAR);// "߳";
    addProperty(fileds.diametor  ,CivTableTemp::FILED_VARCHAR);// "ֱ";
    addProperty(fileds.baseLevel  ,CivTableTemp::FILED_VARCHAR);// "ˮλ";
    addProperty(fileds.initLevel  ,CivTableTemp::FILED_VARCHAR);// "ʼˮλ";
    addProperty(fileds.highLevel  ,CivTableTemp::FILED_VARCHAR);// "ˮλ";
    addProperty(fileds.lowLevel  ,CivTableTemp::FILED_VARCHAR);// "ˮλ";
    addProperty(fileds.flowIn  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.flowOut  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.leveHeight  ,CivTableTemp::FILED_VARCHAR);// "Һλ߶";
    addProperty(fileds.capacity  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.percentage  ,CivTableTemp::FILED_VARCHAR);// "װˮذ";
    addProperty(fileds.status  ,CivTableTemp::FILED_VARCHAR);// "״̬";
    addProperty(fileds.code  ,CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser  ,CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modifyUser  ,CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime  ,CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime  ,CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.SymbolAngle  ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType  ,CivTableTemp::FILED_VARCHAR);// "";
}

/**
  ˮ
*/
CivResourcesTableTemp::CivResourcesTableTemp() :CivTableTemp()
{
    setName(RESIVOIR);

    TableFileds fileds;

    addProperty(fileds.ID  ,CivTableTemp::FILED_VARCHAR);// "id";
    addProperty(fileds.geom  ,CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.thePoint  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.xCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.headPattern  ,CivTableTemp::FILED_VARCHAR);// "ˮͷģʽ";
    addProperty(fileds.elev  ,CivTableTemp::FILED_VARCHAR);// "߳";
    addProperty(fileds.head  ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
    addProperty(fileds.flow  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.code  ,CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser  ,CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modifyUser  ,CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime  ,CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime  ,CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.SymbolAngle  ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType  ,CivTableTemp::FILED_VARCHAR);// "";
}

/**

*/
CivValveTableTemp::CivValveTableTemp() :CivTableTemp()
{
    setName(VALVE);

    TableFileds fileds;
    addProperty(fileds.id  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.geom  ,CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.xCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.startPoint  ,CivTableTemp::FILED_VARCHAR);// "ʼڵ";
    addProperty(fileds.endPoint  ,CivTableTemp::FILED_VARCHAR);// "ֹڵ";
    addProperty(fileds.diameter  ,CivTableTemp::FILED_VARCHAR);// "ֱ";
    addProperty(fileds.status  ,CivTableTemp::FILED_VARCHAR);// "״̬";
    addProperty(fileds.type  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.setting  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.loss  ,CivTableTemp::FILED_VARCHAR);// "ʧϵ";
    addProperty(fileds.flow  ,CivTableTemp::FILED_VARCHAR);// " ";
    addProperty(fileds.veclocity  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.headLoss  ,CivTableTemp::FILED_VARCHAR);// "ˮͷʧ";
    addProperty(fileds.code  ,CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser  ,CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modityUser  ,CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime  ,CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime  ,CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.symbolAngle  ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType  ,CivTableTemp::FILED_VARCHAR);// "";
}

/**
   ڵģ洢
*/
CivNodeResultTableTemp::CivNodeResultTableTemp() :CivTableTemp()
{

    setName(NODERESULTTABLE);

    NodeResultTable nodeTable;
    addProperty(nodeTable.Number, CivTableTemp::FILED_VARCHAR);
    addProperty(nodeTable.dPressure, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dHead, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dElevation, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dDemand, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dTankVolume, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dTankMaxVolume, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dTankLevel, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dQuality, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dDate, CivTableTemp::FILED_DATE);
    addProperty(nodeTable.dInterval, CivTableTemp::FILED_INT);
    addProperty(nodeTable.dModifyTime, CivTableTemp::FILED_DATETIME);
}

/**
	ģ߱
*/
CivPipeResultTableTemp::CivPipeResultTableTemp() :CivTableTemp()
{

    setName(PIPERESULTTABLE);

    TableField pipeFileds;
    addProperty(pipeFileds.szNo, CivTableTemp::FILED_VARCHAR);
    addProperty(pipeFileds.dFlow, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.nFlowDirect, CivTableTemp::FILED_INT);
    addProperty(pipeFileds.dVelocity, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dUnitHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dFromNodHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dToNodHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dLocalHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dFrictionHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.szStatus, CivTableTemp::FILED_VARCHAR);
    addProperty(pipeFileds.dQuality, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dDate, CivTableTemp::FILED_DATE);
    addProperty(pipeFileds.dInterval, CivTableTemp::FILED_INT);
    addProperty(pipeFileds.dModifyTime, CivTableTemp::FILED_DATETIME);
}

/**
	 ģʽ
*/
CivPatternTableTemp::CivPatternTableTemp() :CivTableTemp()
{
    setName(PATTERNTABLE);

    TableField fileds;
    addProperty(fileds.modelName, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.modelData, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.modelType, CivTableTemp::FILED_INTEGER);
}

/**
	
*/
CivParametorTableTemp::CivParametorTableTemp() :CivTableTemp() 
{
    setName(OPTIONTTABLE);
    TableField fileds;
    addProperty(fileds.name, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.val, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.type, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.netName, CivTableTemp::FILED_VARCHAR64);
}

/**
   ߱
*/
CivCurveTableTemp::CivCurveTableTemp() :CivTableTemp()
{
    setName(CURVETABLE);
    TableField fileds;
    addProperty(fileds.CurveName, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.CurveType, CivTableTemp::FILED_INTEGER);
    addProperty(fileds.CurveData, CivTableTemp::FILED_VARCHAR256);
}
