#ifndef CIVTABLETEMP_H
#define CIVTABLETEMP_H

#include<string>
#include<vector>
#include<map>

#include "CivTypes.h"

struct FieldProperty
{
	std::string mFiledName; //ֶ
	std::string mFieldType; // ֶ
};

#define FiledPropertys std::vector<FieldProperty>
class CivDbConn;
/**
*  ݿģ
*/
class CivTableTemp
{
public:
	// ֶ
	enum FieldType {
		FILED_INT,
		FILED_INTEGER,
		FILED_DOUBLE,
		FILED_VARCHAR,
		FILED_VARCHAR64,
		FILED_VARCHAR128,
		FILED_VARCHAR256,
		FILED_DATETIME,
		FILED_JSON,
		FILED_DATE
	};

	explicit CivTableTemp();

	~CivTableTemp();

	// شsql
	Str createSql();
	/*
	 * @brief 
	*/
	Str name() const { return mTableName; }

	void setName(StrQuote name) { mTableName = name; }

	/**
	*@brief ֶ
	*@fileNameֶ
	*@filedTypeֶ
	*/
	void addProperty(std::string fileName, FieldType filedType);

	/**
	*@brief ݿⴴģ
	*@dbConn: ݿӶ
	*/
	bool updateToDb(CivDbConn* dbConn);

protected:
	Str mTableName;  // 

	FiledPropertys mPropertys; // ֶκֶ
	std::map< FieldType, Str> mFieldTyepMap;
};

/**
 ڵģ
*/
class CivJunctionTableTemp :public CivTableTemp
{
public:
	// ֶ
	typedef struct TableFileds
	{
		Str ID = "id";
		Str geom = "geom";
		Str thePoint = "";
		Str xCoord = "";
		Str yCoord = "";
		Str elev = "߳";
		Str demand = "ˮ";
		Str pattern = "ˮģʽ";
		Str head = "ˮͷ";
		Str freeHead = "ˮͷ";
		Str actualDemand = "ʵˮ";
		Str code = "code";
		Str createUser = "create_user";
		Str modifyUser = "modify_user";
		Str createTime = "create_time";
		Str  modifyTime = "modify_time";
		Str symbolAngle = "symbol_angle";
		Str compType = "";
		Str pressure = "ѹ";
		Str quality = "ˮ";
		Str initQuality = "ʼˮ";
	}JunctionTable;

	explicit CivJunctionTableTemp(Str tableName);

};

/**
    ߱ģ
*/
class CivPipeTableTemp :public CivTableTemp
{
public:
	// ֶ
	typedef struct TableFileds
	{
		Str ID = "id";
		Str geom = "geom";
		Str snNo = "";
		Str thePoint = "";
		Str lastPoint = "ϵ";
		Str length = "ܳ";
		Str material = "ܲ";
		Str diameter = "ܾ";
		Str friction = "Ħϵ";
		Str localLoss = "ֲʧϵ";
		Str initStatus = "ʼ״̬";
		Str buryingTime = "ʱ";
		Str flow = "";
		Str velocity = "";
		Str unitHeadLoss = "λˮͷ";
		Str headLoss = "ˮͷʧ";
		Str unitPressLoss = "λѹ";
		Str pressLoss = "ѹʧ";
		Str lastHead = "ϵˮͷ";
		Str theHead = "ˮͷ";
		Str lastPress = "ϵѹ";
		Str thePress = "ѹ";
		Str localHeadLoss = "ֲˮͷ";
		Str fracHeadLoss = "Ħˮͷ";
		Str status = "״̬";
		Str guid = "guid";
		Str code = "code";
		Str fromCode = "from_code";
		Str fromLayer = "from_layer";
		Str toCode = "to_code";
		Str toLayer = "to_layer";
		Str createUser = "create_user";
		Str modifyUser = "modify_user";
		Str createTime = "create_time";
		Str modifyTime = "modify_time";
		Str remarks = "ע";
		Str quality = "ˮ";
	}PipeTable;
	explicit CivPipeTableTemp();
};

/**
ˮ
*/
class CivPumpTableTemp :public CivTableTemp
{
public:
	typedef struct TableFileds
	{
		Str ID = "id";
		Str geom = "geom";
		Str thePoint = "";
		Str xCoord = "";
		Str yCoord = "";
		Str startPoint = "ʼڵ";
		Str endPoint = "ֹڵ";
		Str curve = "ˮ";
		Str ratio = "תٱ";
		Str flow = "";
		Str headCurve = "";
		Str status = "״̬";
		Str code = "code";
		Str createUser = "create_user";
		Str modifyUser = "modify_user";
		Str createTime = "create_time";
		Str modifyTime = "modify_time";
		Str SymbolAngle = "symbol_angle";
		Str compType = "";
		Str power = "";
	 } PumpTable;
	explicit CivPumpTableTemp();
};

/**
   ˮ
*/
class CivTankTableTemp :public CivTableTemp
{
public:
	typedef struct TableFileds
	{
		Str ID = "id";
		Str geom = "geom";
		Str thePoint = "";
		Str xCoord = "";
		Str yCoord = "";
		Str elev = "߳";
		Str diametor = "ֱ";
		Str baseLevel = "ˮλ";
		Str initLevel= "ʼˮλ";
		Str highLevel = "ˮλ";
		Str lowLevel = "ˮλ";
		Str flowIn = "";
		Str flowOut = "";
		Str leveHeight = "Һλ߶";
		Str capacity = "";
		Str volCurve = "ݻ";
		Str percentage = "װˮذ";
		Str status = "״̬";
		Str code = "code";
		Str createUser = "create_user";
		Str modifyUser = "modify_user";
		Str createTime = "create_time";
		Str modifyTime = "modify_time";
		Str SymbolAngle = "symbol_angle";
		Str compType = "";
	}TankTable;
	explicit CivTankTableTemp();
};

/**
  ˮ
*/
class CivResourcesTableTemp :public CivTableTemp
{
public:
	typedef struct TableFileds
	{
		Str ID = "id";
		Str geom = "geom";
		Str thePoint = "";
		Str xCoord = "";
		Str yCoord = "";
		Str headPattern = "ˮͷģʽ";
		Str elev = "߳";
		Str head = "ˮͷ";
		Str flow = "";
		Str code = "code";
		Str createUser = "create_user";
		Str modifyUser = "modify_user";
		Str createTime = "create_time";
		Str modifyTime = "modify_time";
		Str SymbolAngle = "symbol_angle";
		Str compType = "";
	}ResourcesTable;
	explicit CivResourcesTableTemp();
};

/**

*/
class CivValveTableTemp :public CivTableTemp
{
public:
	typedef struct TableFileds
	{
		Str id = "";
		Str geom = "geom";
		Str xCoord = "";
		Str yCoord = "";
		Str startPoint = "ʼڵ";
		Str endPoint = "ֹڵ";
		Str diameter = "ֱ";
		Str status = "״̬";
		Str type = "";
		Str setting = "";
		Str loss = "ʧϵ";
		Str flow = " ";
		Str veclocity = "";
		Str headLoss = "ˮͷʧ";
		Str code= "code";
		Str createUser= "create_user"	;
		Str modityUser = "modify_user";
		Str createTime= "create_time";
		Str modifyTime = "modify_time"  ;
		Str symbolAngle= "symbol_angle";
		Str compType = "";
	}ValveTable;
	explicit CivValveTableTemp();
};

/**
   ڵģ洢
*/
class CivNodeResultTableTemp :public CivTableTemp
{
public:
	typedef struct TableField
	{
		Str Number = "";
		Str dHead = "ˮͷ";
		Str dPressure = "ѹ";
		Str dElevation = "";
		Str dDemand = "ʵˮ";
		Str dTankVolume = "ˮ";
		Str dTankMaxVolume = "ˮ";
		Str dTankLevel = "Һλ߶";
		Str dQuality = "ˮ";
		Str dDate = "";
		Str dInterval = "ʱ";
		Str dModifyTime = "޸ʱ";
	} NodeResultTable;
	explicit CivNodeResultTableTemp();
};
/**
	ģ߱
*/
class CivPipeResultTableTemp :public CivTableTemp
{
public:
	typedef struct TableField
	{
		Str szNo = "";
		Str dFlow = "";
		Str nFlowDirect = "";
		Str dVelocity = "";
		Str dHeadloss = "ˮͷʧ";
		Str dUnitHeadloss = "λˮͷ";
		Str dFromNodHeadloss = "ϵˮͷ";
		Str dToNodHeadloss = "ˮͷ";
		Str dLocalHeadloss = "ֲˮͷ";
		Str dFrictionHeadloss = "Ħˮͷ";
		Str szStatus = "״̬";
		Str dQuality = "ˮ";
		Str dDate = "";
		Str dInterval = "ʱ";
		Str dModifyTime = "޸ʱ";
	}PipeResultTable;
	explicit CivPipeResultTableTemp();
};

/**
	 ģʽ
*/
class CivPatternTableTemp :public CivTableTemp
{
public:
	typedef struct TableField
	{
		Str modelName = "model_name";
		Str modelType = "model_type";
		Str modelData = "model_data";
	} PatternTable;

	enum PatternType
	{
		PATTERN_DEMAND,// ˮģʽ
		PATTERN_PRESS// ѹģʽ
	};
	explicit CivPatternTableTemp();
};

/**
	
*/
class CivParametorTableTemp :public CivTableTemp
{
public:
	typedef struct TableField
	{
		Str name = "";
		Str val = "ֵ";
		Str type = "";
		Str netName = "";
	}ParametorTable;
	explicit CivParametorTableTemp();
};

/**
   ߱
*/
class CivCurveTableTemp :public CivTableTemp
{
public:
	typedef struct TableField
	{
		Str CurveName = "curve_name";
		Str CurveType = "curve_type";
		Str CurveData = "curve_data";
	}CurveTable;

	// 
	enum CurveType
	{
		CURVE_ELEV,// ˮ
		CURVE_EFFIC,//ˮЧ
		CURVE_VOLUME,// ˮݻˮ
		CURVE_HEADLOSS //淧ŵˮͷʧ
	};
	explicit CivCurveTableTemp();
};

#endif // !CIVTABLETEMP_H



