#ifndef CIVTYPES_H
#define CIVTYPES_H

#include <map>
#include<string>
#include <vector>
#include <set>

typedef  std::string   Str;
typedef  const std::string& StrQuote;

#define Tables std::vector<Str>

#define PIPELINE Str("ܶ")
#define PIPENODE Str("ڵ")
#define RESIVOIR Str("ˮ")
#define TANK Str("ˮ")
#define PUMP Str("ˮ")
#define VALVE Str("")

#define NODERESULTTABLE Str("__node_result__")
#define PIPERESULTTABLE Str("__pipe_result__")
#define PATTERNTABLE Str("__pattern__")
#define CURVETABLE Str("__curve__")
#define OPTIONTTABLE Str("__parameter__")

#define PRV_TYPE Str("ѹ")
#define PSV_TYPE Str("ѹ")
#define PBV_TYPE Str("ѹƶ")
#define FCV_TYPE Str("Ʒ")
#define TCV_TYPE Str("Ʒ")
#define GPV_TYPE Str("淧")


// ܵ
#define Node std::map<Str,Str>
#define Nodes std::vector<Node>

// ߼
#define Componet std::map<Str,Str>
#define Componets std::vector<Componet>

// ֶι
#define FiledFilter std::map<Str,std::set<Str>>

// 
enum SectType {
	_TITLE, _JUNCTIONS, _RESERVOIRS, _TANKS, _PIPES, _PUMPS,
	_VALVES, _CONTROLS, _RULES, _DEMANDS, _SOURCES, _EMITTERS,
	_PATTERNS, _CURVES, _QUALITY, _STATUS, _ROUGHNESS, _ENERGY,
	_REACTIONS, _MIXING, _REPORT, _TIMES, _OPTIONS,
	_COORDS, _VERTICES, _LABELS, _BACKDROP, _TAGS, _END
};

// 
enum ValvesType
{
	PRV,   /* ѹ   */
	PSV,   /* ѹ   */
	PBV,   /* ѹƶ */
	FCV,   /* Ʒ */
	TCV,  /*Ʒ */
	GPV  /* 淧 */
};

// ˮò
enum PumpParameter
{
	POWER,  // ˮõĹֵhp(kW)
	HEAD,  // ˮϵID
	SPEED,  // ٶãٶΪ1.00ζˮùرգ
	PATTERN  // ʱģʽIDٶʱ仯
};


// [REPORT] 
// ģɵݡ
struct Report {
	Str PAGESIZES;
	Str NODES; // NONE/ALL/node1 node2 ... 
	Str LINKS; // NONE/ALL/link1 link2 ... 
	Str STATUS;
	Str SUMMARY; // 
	Str ENERGY;
};


/****************************** ֶ****************************************************/
// ˮ
//[PUMPS]
//; ID              	Node1           	Node2           	Parameters
struct PumpFields {
	/**
	* POWERˮõĹֵhp(kW)
	* HEADˮϵID
	* SPEEDٶãٶΪ1.00ζˮùرգ
	* PATTERNʱģʽIDٶʱ仯
	*/
	Str ID = "";
	Str node1 = ""; // ˮӵα
	Str node2 = "ϵ"; // ˮӵιܶ
	Str power = "";  // ˮõĹֵhp(kW)
	Str head = "";
	Str speed = "ٶ"; // ٶãٶΪ1.00ζˮùرգ
	Str pattern = "ˮ";// ʱģʽIDٶʱ仯
};

//[VALVES]
//; ID              	Node1           	Node2           	Diameter    	Type	Setting     	MinorLoss
struct ValvesFields {
	Str ID = ""; // ˮñı
	Str node1 = "ϵ"; // ˮӵα
	Str node2 = ""; // ˮӵιܶ
	Str Diameter = "ܾ";// ֱ
	Str type = ""; // 
	Str setting = ""; // ͬŶӦͬ
	Str minorLoss = "ֲʧϵ"; //
};

// ˮֶ
struct ResivoirFields {
	Str ID = "";
	Str Elev = "߳";
	Str Head = "ˮͷ";
	Str X_Coord = "";
	Str Y_Coord = "";
	Str Pattern = "ˮͷģʽ";
	Str Flow = "";
};

//;ID  Node1   Node2   Length   Diameter  	Roughness  MinorLoss  Status
struct PipeFields {
	Str ID = "";
	Str Node1 = Str("ϵ");
	Str Node2 = Str("");
	Str Length = Str("ܳ");
	Str Diameter = Str("ܾ"); // ܾ
	Str Roughness = Str("Ħϵ"); //
	Str MinorLoss = Str("ֲˮͷ");
	Str Status = Str("״̬");
};

// ڵ 
struct  JunctionsFields {
	Str ID = "";
	Str Elev = "߳";
	Str Demand = "ˮ";
	Str Pattern = "ˮģʽ";
	Str X_Coord = "";
	Str Y_Coord = "";
	Str InitQual = "ʼˮ";
};

// ģʽֶ
struct PatternFields {
	Str Name = "ģʽ";
	Str Value = "ֵ";
	Str NetName = "";
};

// ߶
struct CurvesFields {
	Str Label = "";
	Str XCoord = "x";
	Str YCoord = "y";
	Str Type = "";
};

// ѡ
struct ParameterFileds {
	Str name = "";
	Str val = "ֵ";
	Str type = "";/*
	[REACTIONS]
	[SOURCES]
	[MIXING]
	[OPTIONS]
	[TIMES]
	[REPORT]
*/
	Str netName = "";
};

// ˮ
//[TANKS] ;ID Elevation InitLevel MinLevel MaxLevel Diameter MinVol VolCurve
struct TanksFields {
	Str ID = "";
	Str Elev = "߳";
	Str InitLevel = "ʼˮλ";
	Str MinLevel = "ˮλ";
	Str MaxLevel = "ˮλ";
	Str Diameter = "ֱ";
	Str MinVol = "";
	Str VolCurve = "ݻ";
	Str X_Coord = "";
	Str Y_Coord = "";
};

/********************************end **************************************************/
struct NodeFieldName
{
	Str Number = "";
	Str dFlow = "";
	Str dHead = "ˮͷ";
	Str dPressure = "ѹ";
	Str dElevation = "";
	Str dDemand = "ʵˮ";
	Str dTankVolume = "ˮ";
	Str dTankMaxVolume = "ˮ";
	Str dTankLevel = "Һλ߶";
	Str dQuality = "ˮ";
	Str dDate = "";
	Str dInterval = "ʱ";
	Str dModifyTime = "޸ʱ";
};

struct LinkFiledName
{
	Str szNo = "";
	Str dFlow = "";
	Str nFlowDirect = "";
	Str dVelocity = "";
	Str dHeadloss = "ˮͷʧ";
	Str dUnitHeadloss = "λˮͷ";
	Str dFromNodHeadloss = "ϵˮͷ";
	Str dToNodHeadloss = "ˮͷ";
	Str dLocalHeadloss = "ֲˮͷ";
	Str dFrictionHeadloss = "Ħˮͷ";
	Str szStatus = "״̬";
	Str dQuality = "ˮ";
	Str dDate = "";
	Str dInterval = "ʱ";
	Str dModifyTime = "޸ʱ";
};

//  ˮܵ 
struct  NodeResultItem
{
	char szNo[32]; // 
	float dFlow; // 
	float dHead; // ˮͷ
	float dPressure; // ѹ
	float dElevation; // 
	float dDemand; // ʵˮ
	float dTankVolume; // ˮ
	float dTankMaxVolume; // ˮ
	float dTankLevel; // Һλ߶
	float dQuality;// ˮ
	char dDate[32];// 
	int dInterval; // ʱ
};

// ˮ߽
struct  LinkResultItem
{
	char szNo[32]; // 
	float dFlow; // 
	short nFlowDirect; // 
	float dVelocity; // 
	float dHeadloss; // ˮͷʧ
	float dUnitHeadloss; // λˮͷʧ
	float dFromNodHeadloss; // ϵˮͷ
	float dToNodHeadloss; // ˮͷ
	float dLocalHeadloss; // ֲˮͷʧ
	float dFrictionHeadloss; // Ħˮͷʧ
	float dQuality;// ˮ
	char  szStatus[20]; // ״̬
	char dDate[32];// 
	int dInterval; // ʱ
};

#define NodeResultItems std::map<Str, NodeResultItem>
#define LinkResultItems std::map<Str, LinkResultItem>



#endif // !CIVTYPES_H



